#ifndef MPEG3IO_H
#define MPEG3IO_H

#include <stdio.h>
#include "mpeg3css.h"
#include "mpeg3private.inc"
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>

#define MPEG3IO_MAX_FILE_CHUNKS 16

/* Filesystem structure */

typedef struct
{
	FILE *fd;
	mpeg3_css_t *css;          /* Encryption object */
	char path[MPEG3_STRLEN];
	char path_s[MPEG3_STRLEN];
/* Hypothetical position of file pointer */
	off_t current_byte;
	int current_file;
	off_t total_bytes;
	int numfiles;
	off_t filepos[MPEG3IO_MAX_FILE_CHUNKS];
	char*paths[MPEG3IO_MAX_FILE_CHUNKS];
} mpeg3_fs_t;

#define mpeg3io_get_fd(fs) (fileno(((mpeg3_fs_t *)(fs))->fd))
#define mpeg3io_eof(fs) ((fs)->current_byte >= (fs)->total_bytes)
#define mpeg3io_bof(fs) ((fs)->current_byte < 0)


#endif
